texture g_txSrcColor;
texture g_txSrcNormal;
texture g_txSrcPosition;
texture g_txSrcVelocity;

texture g_txSceneColor;
texture g_txSceneNormal;
texture g_txScenePosition;
texture g_txSceneVelocity;

sampler2D g_samSrcColor = sampler_state {
	Texture 	= <g_txSrcColor>;
	AddressU 	= Wrap;
	AddressV 	= Wrap;
	MinFilter = Point;
	MagFilter = Linear;
	MipFilter = Linear;
};
sampler2D g_samSrcNormal = sampler_state {
	Texture 	= <g_txSrcNormal>;
	AddressU 	= Wrap;
	AddressV 	= Wrap;
	MinFilter = Point;
	MagFilter = Linear;
	MipFilter = Linear;
};
sampler2D g_samSrcPosition = sampler_state {
	Texture 	= <g_txSrcPosition>;
	AddressU 	= Wrap;
	AddressV 	= Wrap;
	MinFilter = Point;
	MagFilter = Linear;
	MipFilter = Linear;
};
sampler2D g_samSrcVelocity = sampler_state {
	Texture 	= <g_txSrcVelocity>;
	AddressU 	= Wrap;
	AddressV 	= Wrap;
	MinFilter = Point;
	MagFilter = Linear;
	MipFilter = Linear;
};

sampler2D g_samSceneColor = sampler_state {
	Texture 	= <g_txSceneColor>;
	AddressU 	= Wrap;
	AddressV 	= Wrap;
	MinFilter = Point;
	MagFilter = Linear;
	MipFilter = Linear;
};
sampler2D g_samSceneNormal = sampler_state {
	Texture 	= <g_txSceneNormal>;
	AddressU 	= Wrap;
	AddressV 	= Wrap;
	MinFilter = Point;
	MagFilter = Linear;
	MipFilter = Linear;
};
sampler2D g_samScenePosition = sampler_state {
	Texture 	= <g_txScenePosition>;
	AddressU 	= Wrap;
	AddressV 	= Wrap;
	MinFilter = Point;
	MagFilter = Linear;
	MipFilter = Linear;
};
sampler2D g_samSceneVelocity = sampler_state {
	Texture 	= <g_txSceneVelocity>;
	AddressU 	= Wrap;
	AddressV 	= Wrap;
	MinFilter = Point;
	MagFilter = Linear;
	MipFilter = Linear;
};

float2 PixelCoordsDownFilter[16] = {
  { 1.5,  -1.5 },
  { 1.5,  -0.5 },
  { 1.5,   0.5 },
  { 1.5,   1.5 },

  { 0.5,  -1.5 },
  { 0.5,  -0.5 },
  { 0.5,   0.5 },
  { 0.5,   1.5 },

  {-0.5,  -1.5 },
  {-0.5,  -0.5 },
  {-0.5,   0.5 },
  {-0.5,   1.5 },

  {-1.5,  -1.5 },
  {-1.5,  -0.5 },
  {-1.5,   0.5 },
  {-1.5,   1.5 },
};

float2 TexelCoordsDownFilter[16] <
	string ConvertPixelsToTexels = "PixelCoordsDownFilter";
>;

float4 DownFilter( in float2 Tex : TEXCOORD0 ) : COLOR0 {
  float4 Color = 0;

  for (int i = 0; i < 16; i++) {
  	Color += tex2D( g_samSrcColor, Tex + TexelCoordsDownFilter[i].xy );
  }

  return Color / 16;
}

technique PostProcess {
  pass p0<
		float fScaleX = 0.25f;
		float fScaleY = 0.25f;
  > {
    AlphaBlendEnable 	= true;
    SrcBlend 					= SrcAlpha;
    DestBlend 				= InvSrcAlpha;
    CullMode 					= CCW;
    FillMode 					= Solid;
    FogEnable 				= False;
    VertexShader 			= null;
    PixelShader 			= compile ps_2_0 DownFilter();
    ZEnable 					= false;
  }
}